//+------------------------------------------------------------------+
//|                                       Ma_Distance_From_Price.mq4 |
//|                              transport_david , David W Honeywell |
//|                                        transport.david@gmail.com |
//|                                            this version : mladen |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 clrRed
#property indicator_color2 clrLimeGreen
#property indicator_width1 2
#property indicator_width2 2

//
//
//
//
//

string UniqueID = "MADIST_";

extern int                MaPeriod           =   9;  // default = 9,0,3,0,15 on H1 charts
extern int                MaShift            =   0;
extern ENUM_MA_METHOD     MaMethod_0to3      =   3;
extern ENUM_APPLIED_PRICE AppliedPrice_0to6  =   0;
extern double             PipBuffer          = 15; // If Ma > Price+PipBuffer then arrow , If Ma < Price-PipBuffer then arrow
extern bool               ShowDistanceText   = true;
extern color              DistanceText_color = clrMediumVioletRed;
extern bool               alertsOn           = false;
extern bool               alertsOnCurrent    = true;
extern bool               alertsMessage      = true;
extern bool               alertsSound        = false;
extern bool               alertsEmail        = false;
extern bool               alertsNotification = false;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
int pipMult = 10000;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   pipMult = (int)(1/(_Point*MathPow(10,MathMod(_Digits,2))));
   SetIndexStyle(0,DRAW_ARROW,0,2); SetIndexArrow(0,226); SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_ARROW,0,2); SetIndexArrow(1,225); SetIndexBuffer(1,ExtMapBuffer2);
   return(0);
}
int deinit()
{
   ObjectsDeleteAll(0, UniqueID, 0);
   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   static bool last_arrow_up = false;
   static bool last_arrow_down = false;
   
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         //double pipMult = MathPow(10,_Digits%2);
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for (int i=limit; i>=0; i--)
   {
      double MaCurrent = iMA(NULL,0,MaPeriod,MaShift,MaMethod_0to3,AppliedPrice_0to6,i);
         ExtMapBuffer1[i] = EMPTY_VALUE;
         ExtMapBuffer2[i] = EMPTY_VALUE;
         if (!last_arrow_down && ( MaCurrent > ( High[i] + PipBuffer/pipMult))) {
            last_arrow_down = true;
            last_arrow_up = false;
            ExtMapBuffer1[i] = High[i]+iATR(NULL,0,15,i);
         }
         if (!last_arrow_up && ( MaCurrent < ( Low[i]  - PipBuffer/pipMult))) {
            last_arrow_down = false;
            last_arrow_up = true;
            ExtMapBuffer2[i] = Low[i] -iATR(NULL,0,15,i);
         }
   }
   double MaCurrent_now = iMA(NULL,0,MaPeriod,MaShift,MaMethod_0to3,AppliedPrice_0to6,0);
   double MaDiff = Close[0]-MaCurrent;
   DrawDistanceText(MathRound(MaDiff*pipMult));
   manageAlerts();
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void DrawDistanceText( double pipDist)
{
//string        item1  = UniqueID+"Box";
string        item2  = UniqueID+"Text";
  
    //ObjectDelete(item1);
    //ObjectCreate(item1, OBJ_LABEL,0,0,0);
    //ObjectSet(item1, OBJPROP_CORNER,1);
    //ObjectSet(item1, OBJPROP_XDISTANCE,-8);
    //ObjectSet(item1, OBJPROP_YDISTANCE,-4);
    //ObjectSet(item1, OBJPROP_BACK, false);
    //ObjectSet(item1, OBJPROP_COLOR, clrBlack); //C'010,010,010'
    //ObjectSetText(item1, "gggggggg",11, "Webdings");
    
    ObjectDelete(item2);
    ObjectCreate(item2,OBJ_LABEL,0,0,0);
    ObjectSet(item2,OBJPROP_CORNER,1);
    ObjectSet(item2,OBJPROP_YDISTANCE,10);
    ObjectSet(item2,OBJPROP_XDISTANCE,10);
    ObjectSet(item2,OBJPROP_BACK,false);
    ObjectSetText(item2,"MA ("+MaPeriod+") Distance = "+DoubleToStr(pipDist,0)+" pips",7,"Verdana",DistanceText_color);

}//End DrawAlertBox

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (ExtMapBuffer1[whichBar] != EMPTY_VALUE) doAlert(whichBar,"down");
      if (ExtMapBuffer2[whichBar] != EMPTY_VALUE) doAlert(whichBar,"up");
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" - ma distance from price signal "+doWhat;
          if (alertsMessage)      Alert(message);
          if (alertsEmail)        SendMail(Symbol()+"ma distance from price ",message);
          if (alertsNotification) SendNotification(message);
          if (alertsSound)        PlaySound("alert2.wav");
   }
}

